'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getScrollInfo = require('get-scroll-info');

var isRunning = false;

var easeInOutCubic = function easeInOutCubic(t, b, c, d) {
    if ((t /= d / 2) < 1) {
        return c / 2 * t * t * t + b;
    }
    return c / 2 * ((t -= 2) * t * t + 2) + b;
};

var smoothScrollTo = function smoothScrollTo(to, duration, el, callback) {
    el = (0, _getScrollInfo.getScrollNode)(el);
    if (!duration) {
        duration = 900;
    }
    var from = el.scrollTop;
    var go = to - from;
    var beginTimeStamp = void 0;
    var scrollTo = function scrollTo(timeStamp) {
        if (isRunning) {
            return false;
        } else {
            isRunning = true;
        }
        beginTimeStamp = beginTimeStamp || timeStamp;
        var elapsedTime = timeStamp - beginTimeStamp;
        var progress = easeInOutCubic(elapsedTime, from, go, duration);
        el.scrollTop = progress;
        if (elapsedTime < duration) {
            requestAnimationFrame(scrollTo);
        } else {
            if ('function' === typeof callback) {
                isRunning = false;
                callback();
            }
        }
    };
    requestAnimationFrame(scrollTo);
};

exports.default = smoothScrollTo;
module.exports = exports['default'];